//-------------------------------------------------------------------------------------
//	ping_pong_simple
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
//	Phil le   18/01/2013  
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
//	includes
//-------------------------------------------------------------------------------------
#define classe_e
#include"base.h"
#undef classe_e
//-------------------------------------------------------------------------------------
//gestion des interruptions
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
//reception d'un message en provenance de la liaison RS232
//-------------------------------------------------------------------------------------
ISR(USART_RXC_vect)
{
	uint8_t v;
	
	cli();
	
	v=rs232_rx_8();
	rs232_tx_8(v);
	PORTC=v;

	sei();
}
//-------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------
//programme principal
//-------------------------------------------------------------------------------------
int main(void)
{	
	DDRC=255;

	PORTC=255;
		
	//init rs232 en bidirectionnel à 115200 bauds
	rs232_init(16,1);
	
	sei();
	
	//boucle infinie
	while(1)
	{
	}
		
	return 0;
}

//-------------------------------------------------------------------------------------
//routines
//-------------------------------------------------------------------------------------



//-------------------------------------------------------------------------------------
//initialisation de la transmission
//-------------------------------------------------------------------------------------
void rs232_init(unsigned char baud,unsigned char isr_rx)
{
	cli();
	
	//reglage de la vitesse
 	UBRRH=(unsigned char)(baud>>8);
	UBRRL=(unsigned char)baud;
	
	//autorisation transmission reception
	UCSRB=(1<<RXEN)|(1<<TXEN);
	
	//reglage protocole (8 bits de donnees, 2 bits de stop)
	UCSRC=(1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
	
	//reglage mode asynchrone
 	UCSRC=UCSRC | 64;
 	
 	//reglage double debit
	UCSRA=UCSRA | 2;
	
	//autorisation interruption sur reception
	if (isr_rx!=0)
	{
		UCSRB = UCSRB | 128;
	}
	
	sei();
}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
//reception d'un mot de 8 bits
//-------------------------------------------------------------------------------------
unsigned char rs232_rx_8(void)
{
	//attente de reception
	while (!(UCSRA & (1<<RXC)))
	{
	}
	
	//reception et retour
	return UDR;
}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
//emission d'un mot de 8 bits
//-------------------------------------------------------------------------------------
void rs232_tx_8(unsigned char v)
{
	//cli();
	
	//attente buffer emission vide
	while (!(UCSRA & (1<<UDRE)))
	{
	}

	//envoi
	UDR=v;
	
	//sei();
}
//-------------------------------------------------------------------------------------


